var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/* eslint-disable no-console */
/* eslint-disable @typescript-eslint/no-explicit-any */
import { BaseWalletAdapter, WalletAccountError, WalletDisconnectionError, WalletNotReadyError, WalletPublicKeyError, WalletReadyState, WalletSignMessageError, WalletSignTransactionError, WalletError, isVersionedTransaction, } from '@solana/wallet-adapter-base';
import { PublicKey, Keypair, } from '@solana/web3.js';
import nacl from 'tweetnacl';
import { decrypt, encrypt, getNonce } from '@renec-foundation/escrow-sdk';
export var E2EWalletName = 'E2E';
var E2EWalletAdapter = /** @class */ (function (_super) {
    __extends(E2EWalletAdapter, _super);
    function E2EWalletAdapter(config) {
        if (config === void 0) { config = {}; }
        var _this = _super.call(this) || this;
        _this.name = E2EWalletName;
        _this.url = 'http://2e2.renec.foundation/';
        _this.icon = 'E2E';
        _this.supportedTransactionVersions = new Set(['legacy', 0]);
        _this._readyState = WalletReadyState.Installed;
        _this._accountChanged = function (newPublicKeyStr) {
            if (!newPublicKeyStr)
                return;
            var publicKey = _this._publicKey;
            if (!publicKey)
                return;
            var newPublicKey;
            try {
                newPublicKey = new PublicKey(newPublicKeyStr);
            }
            catch (error) {
                _this.emit('error', new WalletPublicKeyError(error === null || error === void 0 ? void 0 : error.message, error));
                return;
            }
            if (!newPublicKey || publicKey.equals(newPublicKey))
                return;
            _this._publicKey = newPublicKey;
            _this.emit('connect', newPublicKey);
        };
        _this._connecting = false;
        _this._wallet = null;
        _this._publicKey = null;
        _this._underlyingWallet = config.keypair || Keypair.generate();
        return _this;
    }
    Object.defineProperty(E2EWalletAdapter.prototype, "publicKey", {
        get: function () {
            return this._publicKey;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(E2EWalletAdapter.prototype, "connecting", {
        get: function () {
            return this._connecting;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(E2EWalletAdapter.prototype, "connected", {
        get: function () {
            var _a;
            return !!((_a = this._wallet) === null || _a === void 0 ? void 0 : _a.isConnected);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(E2EWalletAdapter.prototype, "readyState", {
        get: function () {
            return this._readyState;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(E2EWalletAdapter.prototype, "wallet", {
        get: function () {
            return this._wallet;
        },
        enumerable: false,
        configurable: true
    });
    E2EWalletAdapter.prototype.connect = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                try {
                    if (this.connected || this.connecting)
                        return [2 /*return*/];
                    if (this._readyState !== WalletReadyState.Installed)
                        throw new WalletNotReadyError();
                    this._connecting = true;
                    if (this._underlyingWallet) {
                        this._publicKey = (_a = this._underlyingWallet) === null || _a === void 0 ? void 0 : _a.publicKey;
                    }
                    else {
                        throw new WalletAccountError('No account found');
                    }
                    this.emit('connect', this._publicKey);
                }
                catch (error) {
                    this.emit('error', error);
                    throw error;
                }
                finally {
                    this._connecting = false;
                }
                return [2 /*return*/];
            });
        });
    };
    E2EWalletAdapter.prototype.disconnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        wallet = this._wallet;
                        if (!wallet) return [3 /*break*/, 4];
                        this._wallet = null;
                        this._publicKey = null;
                        wallet.off('accountChanged', this._accountChanged);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, wallet.disconnect()];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        this.emit('error', new WalletDisconnectionError(error_1 === null || error_1 === void 0 ? void 0 : error_1.message, error_1));
                        return [3 /*break*/, 4];
                    case 4:
                        this.emit('disconnect');
                        return [2 /*return*/];
                }
            });
        });
    };
    E2EWalletAdapter.prototype.sendTransaction = function (transaction, connection, options, signers) {
        return __awaiter(this, void 0, void 0, function () {
            var allSigners;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        allSigners = __spreadArray(__spreadArray([], (signers || []), true), [this._underlyingWallet], false);
                        if (!isVersionedTransaction(transaction)) return [3 /*break*/, 2];
                        transaction.sign(allSigners);
                        return [4 /*yield*/, connection.sendTransaction(transaction, { maxRetries: 5 })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [4 /*yield*/, connection.sendTransaction(transaction, allSigners)];
                    case 3: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    E2EWalletAdapter.prototype.sendTransactionWithSigners = function (transaction, connection, signers) {
        return __awaiter(this, void 0, void 0, function () {
            var error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.sendTransaction(transaction, connection, {}, signers)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        error_2 = _a.sent();
                        this.emit('error', new WalletSignTransactionError(error_2 === null || error_2 === void 0 ? void 0 : error_2.message, error_2));
                        throw error_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    E2EWalletAdapter.prototype.signTransaction = function (transaction) {
        if (window.Cypress.env('E2E_WALLET_DISABLE_TRANSACTION_SIGNING')) {
            this.emit('error', new WalletSignTransactionError('Cypress has requested to decline all transaction signing.'));
        }
        else {
            if (isVersionedTransaction(transaction)) {
                transaction.sign([this._underlyingWallet]);
            }
            else {
                transaction.partialSign(this._underlyingWallet);
            }
        }
        return transaction;
    };
    E2EWalletAdapter.prototype.signAllTransactions = function (transactions) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, transactions_1, tx;
            return __generator(this, function (_a) {
                try {
                    for (_i = 0, transactions_1 = transactions; _i < transactions_1.length; _i++) {
                        tx = transactions_1[_i];
                        this.signTransaction(tx);
                    }
                    return [2 /*return*/, transactions];
                }
                catch (error) {
                    this.emit('error', new WalletSignTransactionError(error === null || error === void 0 ? void 0 : error.message, error));
                    throw error;
                }
                return [2 /*return*/];
            });
        });
    };
    E2EWalletAdapter.prototype.signMessage = function (message) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                try {
                    if (window.Cypress.env('E2E_WALLET_DISABLE_MESSAGE_SIGNING')) {
                        throw new WalletSignMessageError('Cypress has requested to decline all message signing.');
                    }
                    return [2 /*return*/, nacl.sign.detached(message, (_a = this._underlyingWallet) === null || _a === void 0 ? void 0 : _a.secretKey)];
                }
                catch (error) {
                    this.emit('error', new WalletSignMessageError(error === null || error === void 0 ? void 0 : error.message, error));
                    throw error;
                }
                return [2 /*return*/];
            });
        });
    };
    E2EWalletAdapter.prototype.encrypt = function (inputs) {
        return __awaiter(this, void 0, void 0, function () {
            var nonce_1;
            var _this = this;
            return __generator(this, function (_a) {
                try {
                    nonce_1 = getNonce();
                    return [2 /*return*/, inputs.map(function (input) { return ({
                            ciphertext: encrypt(input.cleartext, nonce_1, new PublicKey(input.toPublic), _this._underlyingWallet.secretKey),
                            fromPublic: _this._underlyingWallet.publicKey.toString(),
                            nonce: nonce_1.toString(),
                        }); })];
                }
                catch (error) {
                    this.emit("error", new WalletError(error === null || error === void 0 ? void 0 : error.message, error));
                    throw error;
                }
                return [2 /*return*/];
            });
        });
    };
    E2EWalletAdapter.prototype.decrypt = function (inputs) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, inputs.map(function (input) {
                            var cleartext = decrypt(input.ciphertext, input.nonce, new PublicKey(input.fromPublic), _this._underlyingWallet.secretKey);
                            return cleartext ? cleartext.toString() : null;
                        })];
                }
                catch (error) {
                    this.emit("error", new WalletError(error === null || error === void 0 ? void 0 : error.message, error));
                    throw error;
                }
                return [2 /*return*/];
            });
        });
    };
    return E2EWalletAdapter;
}(BaseWalletAdapter));
export { E2EWalletAdapter };
