var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useCallback, useMemo, } from 'react';
import { useWallet } from '@solana/wallet-adapter-react';
import { Button } from './Button';
import { WalletIcon } from './WalletIcon';
export var WalletDisconnectButton = function (_a) {
    var children = _a.children, disabled = _a.disabled, onClick = _a.onClick, props = __rest(_a, ["children", "disabled", "onClick"]);
    var _b = useWallet(), wallet = _b.wallet, disconnect = _b.disconnect, disconnecting = _b.disconnecting;
    var handleClick = useCallback(function (event) {
        if (onClick)
            onClick(event);
        // eslint-disable-next-line @typescript-eslint/no-empty-function
        if (!event.defaultPrevented)
            disconnect().catch(function () { });
    }, [onClick, disconnect]);
    var content = useMemo(function () {
        if (children)
            return children;
        if (disconnecting)
            return 'Disconnecting ...';
        if (wallet)
            return 'Disconnect';
        return 'Disconnect Wallet';
    }, [children, disconnecting, wallet]);
    return (_jsx(Button, __assign({ className: "wallet-adapter-button-trigger", disabled: disabled || !wallet, beginIcon: wallet ? _jsx(WalletIcon, { wallet: wallet }) : undefined, onClick: handleClick }, props, { children: _jsx("span", __assign({ className: "wallet-adapter-button-content" }, { children: content })) })));
};
