var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import React, { useCallback, useLayoutEffect, useMemo, useRef, useState, } from "react";
import { createPortal } from "react-dom";
import Typography from "@mui/material/Typography";
import Dialog from "@mui/material/Dialog";
import DialogTitle from "@mui/material/DialogTitle";
import DialogContent from "@mui/material/DialogContent";
import DialogContentText from "@mui/material/DialogContentText";
import DialogActions from "@mui/material/DialogActions";
import Button from "@mui/material/Button";
import { useWallet } from "@solana/wallet-adapter-react";
import { DemonWalletName, E2EWalletName } from "../adapters";
import { handleRedirectIfDemonNotInstalled, isDemonWalletDetected, openNewWindowWithCallback, getDemonWalletUrl, isMobileDevice, } from "../helpers";
import { useWalletModal } from "../hooks";
import { WalletListItem } from "./WalletListItem";
var useHandleTabKey = function () {
    var ref = useRef(null);
    var setVisible = useWalletModal().setVisible;
    var _a = useState(false), fadeIn = _a[0], setFadeIn = _a[1];
    var _b = useState(null), portal = _b[0], setPortal = _b[1];
    var handleTabKey = useCallback(function (event) {
        var node = ref.current;
        if (!node)
            return;
        // here we query all focusable elements
        var focusableElements = node.querySelectorAll("button");
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        var firstElement = focusableElements[0];
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        var lastElement = focusableElements[focusableElements.length - 1];
        if (event.shiftKey) {
            // if going backward by pressing tab and firstElement is active, shift focus to last focusable element
            if (document.activeElement === firstElement) {
                lastElement.focus();
                event.preventDefault();
            }
        }
        else {
            // if going forward by pressing tab and lastElement is active, shift focus to first focusable element
            if (document.activeElement === lastElement) {
                firstElement.focus();
                event.preventDefault();
            }
        }
    }, [ref]);
    var hideModal = useCallback(function () {
        setFadeIn(false);
        setTimeout(function () { return setVisible(false); }, 150);
    }, [setVisible]);
    useLayoutEffect(function () {
        var handleKeyDown = function (event) {
            if (event.key === "Escape") {
                hideModal();
            }
            else if (event.key === "Tab") {
                handleTabKey(event);
            }
        };
        // Get original overflow
        var overflow = window.getComputedStyle(document.body).overflow;
        // Hack to enable fade in animation after mount
        setTimeout(function () { return setFadeIn(true); }, 0);
        // Prevent scrolling on mount
        document.body.style.overflow = "hidden";
        // Listen for keydown events
        window.addEventListener("keydown", handleKeyDown, false);
        return function () {
            // Re-enable scrolling when component unmounts
            document.body.style.overflow = overflow;
            window.removeEventListener("keydown", handleKeyDown, false);
        };
    }, [hideModal, handleTabKey]);
    useLayoutEffect(function () { return setPortal(document.querySelector("body")); });
    var handleClose = useCallback(function (event) {
        event.preventDefault();
        hideModal();
    }, [hideModal]);
    return { ref: ref, handleTabKey: handleTabKey, fadeIn: fadeIn, portal: portal, handleClose: handleClose, hideModal: hideModal };
};
var DesktopExtensionInstallingConfirmationDialog = function (props) {
    var trans = useWalletModal().trans;
    var openNotice = props.openNotice, handleCloseNotice = props.handleCloseNotice, handleConfirmNotice = props.handleConfirmNotice;
    return (_jsxs(Dialog, __assign({ open: openNotice, onClose: handleCloseNotice, "aria-labelledby": "alert-dialog-title", "aria-describedby": "alert-dialog-description" }, { children: [_jsx(DialogTitle, __assign({ id: "alert-dialog-title" }, { children: trans.install_carax_notice_heading })), _jsx(DialogContent, { children: _jsx(DialogContentText, __assign({ id: "alert-dialog-description" }, { children: trans.install_carax_notice_body })) }), _jsx(DialogActions, { children: _jsx(Button, __assign({ onClick: handleConfirmNotice, autoFocus: true }, { children: "OK" })) })] })));
};
var MobileAppInstallingConfirmation = function (props) {
    var trans = useWalletModal().trans;
    var hideModal = props.hideModal, handleClose = props.handleClose;
    var handleConfirmRedirect = useCallback(function () {
        hideModal();
        handleRedirectIfDemonNotInstalled();
    }, []);
    return (_jsxs("div", __assign({ className: "confirm-open-demon-wallet" }, { children: [_jsx("p", __assign({ className: "confirm-open-demon-wallet--confirm-message" }, { children: trans.connect_using_carax_app })), _jsxs("div", __assign({ className: "confirm-open-demon-wallet-btn-wrapper" }, { children: [_jsx("button", __assign({ className: "confirm-button", onClick: handleClose }, { children: trans.cancel })), _jsx("button", __assign({ className: "confirm-button confirm-button-confirm", onClick: handleConfirmRedirect }, { children: "OK" }))] }))] })));
};
var WalletItemsListBody = function (props) {
    var _a = useWallet(), wallets = _a.wallets, select = _a.select, connect = _a.connect;
    var trans = useWalletModal().trans;
    var _b = React.useState(false), openNotice = _b[0], setOpenNotice = _b[1];
    var handleClose = props.handleClose;
    var demonWallet = useMemo(function () {
        return wallets.find(function (wallet) {
            return wallet.adapter.name === DemonWalletName ||
                wallet.adapter.name === E2EWalletName;
        });
    }, [wallets]);
    var handleClickOpenNotice = useCallback(function () {
        setOpenNotice(true);
    }, []);
    var handleCloseNotice = useCallback(function () {
        setOpenNotice(false);
    }, []);
    var handleConfirmNotice = useCallback(function () {
        openNewWindowWithCallback(getDemonWalletUrl(), function () {
            // eslint-disable-next-line no-console
            console.log('New window has been closed!');
            if (!isDemonWalletDetected()) {
                window.location.reload();
            }
        });
    }, []);
    var handleWalletClick = useCallback(function (event, walletName) {
        if (walletName === DemonWalletName) {
            if (!isDemonWalletDetected()) {
                handleClickOpenNotice();
                return;
            }
        }
        select(walletName);
        handleClose(event);
    }, [
        handleClickOpenNotice,
        handleRedirectIfDemonNotInstalled,
        select,
        connect,
    ]);
    return (_jsxs(_Fragment, { children: [_jsx("div", __assign({ className: "dialog-heading" }, { children: _jsx(Typography, __assign({ className: "dialog-heading__title" }, { children: trans.dialog_heading })) })), _jsx(WalletListItem, { handleClick: function (event) {
                    return handleWalletClick(event, demonWallet.adapter.name);
                }, wallet: demonWallet }, demonWallet.adapter.name), !isMobileDevice && (_jsx(DesktopExtensionInstallingConfirmationDialog, { openNotice: openNotice, handleCloseNotice: handleCloseNotice, handleConfirmNotice: handleConfirmNotice })), _jsx("div", __assign({ className: "first-time-connect-notice" }, { children: _jsx(Typography, __assign({ className: "first-time-connect-notice__text-content" }, { children: trans.first_time_connect_notice })) }))] }));
};
export var WalletModal = function (_a) {
    var _b = _a.className, className = _b === void 0 ? "" : _b;
    var _c = useHandleTabKey(), ref = _c.ref, fadeIn = _c.fadeIn, portal = _c.portal, handleClose = _c.handleClose, hideModal = _c.hideModal;
    var renderContent = function () {
        if (isMobileDevice && !isDemonWalletDetected()) {
            return (_jsx(MobileAppInstallingConfirmation, { hideModal: hideModal, handleClose: handleClose }));
        }
        return (_jsx(WalletItemsListBody, { handleClose: handleClose }));
    };
    return (portal &&
        createPortal(_jsxs("div", __assign({ "aria-labelledby": "wallet-adapter-modal-title", "aria-modal": "true", className: "wallet-adapter-modal ".concat(fadeIn && "wallet-adapter-modal-fade-in", " ").concat(className), ref: ref, role: "dialog" }, { children: [_jsx("div", __assign({ className: "wallet-adapter-modal-container" }, { children: _jsxs("div", __assign({ className: "wallet-adapter-modal-wrapper" }, { children: [_jsx("button", __assign({ onClick: handleClose, className: "wallet-adapter-modal-button-close" }, { children: _jsx("svg", __assign({ width: "14", height: "14" }, { children: _jsx("path", { d: "M14 12.461 8.3 6.772l5.234-5.233L12.006 0 6.772 5.234 1.54 0 0 1.539l5.234 5.233L0 12.006l1.539 1.528L6.772 8.3l5.69 5.7L14 12.461z" }) })) })), renderContent()] })) })), _jsx("div", { className: "wallet-adapter-modal-overlay", onMouseDown: handleClose })] })), portal));
};
