import { isAndroid, isIOS, isMobile } from "react-device-detect";
export * from './translate';
export var MAINNET_RPC_URL = 'https://api-mainnet-beta.renec.foundation:8899';
export var MAINNET_WSS_URL = 'wss://api-mainnet-beta.renec.foundation:8900';
export var TESTNET_RPC_URL = 'https://api-testnet.renec.foundation:8899';
export var TESTNET_WSS_URL = 'wss://api-testnet.renec.foundation:8900';
export var EXPLORER_URL = 'https://explorer.renec.foundation';
export var getNetworkUrls = function (isMainnet) { return isMainnet
    ? { rpc: MAINNET_RPC_URL, wss: MAINNET_WSS_URL }
    : { rpc: TESTNET_RPC_URL, wss: TESTNET_WSS_URL }; };
export var isRunningInCypress = typeof window !== 'undefined' && window.Cypress !== undefined;
export var isDemonWalletDetected = function () { var _a; return ((_a = window.demon) === null || _a === void 0 ? void 0 : _a.sol) || window.Cypress; };
export var isMobileDevice = isAndroid || isIOS || isMobile;
export var getDemonWalletUrl = function () {
    if (isMobileDevice) {
        return "https://carax.renec.org/#/connect?dapp=".concat(window.location.href);
    }
    return "https://chrome.google.com/webstore/detail/demon-wallet/mdjmfdffdcmnoblignmgpommbefadffd";
};
export var handleRedirectIfDemonNotInstalled = function () {
    var url = getDemonWalletUrl();
    if (isIOS) {
        window.location.href = url;
    }
    else {
        window.open(url);
    }
};
export var openNewWindowWithCallback = function (url, callback) {
    var width = window.innerWidth * 3 / 4;
    if (width < 1028)
        width = 1028;
    var height = window.innerHeight * 4 / 5;
    var left = window.screenX + (window.innerWidth - width) / 2;
    var top = window.screenY + (window.innerHeight - height) / 2;
    window.open(url, '_blank', "width=".concat(width, ",height=").concat(height, ",left=").concat(left, ",top=").concat(top));
    window.addEventListener('focus', function () {
        console.log('original window has been focused.');
        callback === null || callback === void 0 ? void 0 : callback();
    });
};
