import { useCallback } from 'react';
import { useWallet } from '@solana/wallet-adapter-react';
import { DemonWalletName } from '../adapters/index';
import { getDemonWalletUrl, isDemonWalletDetected, isRunningInCypress, } from '../helpers';
import { useWalletModal } from './useWalletModal';
export var useConnectWallet = function () {
    var _a = useWallet(), wallet = _a.wallet, connect = _a.connect, select = _a.select;
    var _b = useWalletModal(), visible = _b.visible, setVisible = _b.setVisible;
    var connectWallet = useCallback(function () {
        var _a;
        if (isRunningInCypress) {
            select('E2E');
            connect().catch(function (e) {
                console.log('e', e);
            });
        }
        else {
            if (wallet) {
                if ((_a = wallet === null || wallet === void 0 ? void 0 : wallet.adapter) === null || _a === void 0 ? void 0 : _a.url) {
                    wallet.adapter.url = getDemonWalletUrl();
                }
                if (wallet.adapter.name === DemonWalletName) {
                    if (!isDemonWalletDetected()) {
                        setVisible(!visible);
                        return;
                    }
                }
                connect().catch(function (e) {
                    console.log('e', e);
                });
            }
            else {
                setVisible(!visible);
            }
        }
    }, [
        connect,
        select,
        setVisible,
        visible,
        wallet,
    ]);
    return {
        connectWallet: connectWallet,
    };
};
