import React from 'react';
var DEFAULT_CONTEXT = {
    setVisible: function (_open) {
        // eslint-disable-next-line no-console
        console.error(constructMissingProviderErrorMessage('call', 'setVisible'));
    },
    visible: false,
};
Object.defineProperty(DEFAULT_CONTEXT, 'visible', {
    get: function () {
        // eslint-disable-next-line no-console
        console.error(constructMissingProviderErrorMessage('read', 'visible'));
        return false;
    },
});
function constructMissingProviderErrorMessage(action, valueName) {
    return ('You have tried to ' +
        " ".concat(action, " \"").concat(valueName, "\"") +
        ' on a WalletModalContext without providing one.' +
        ' Make sure to render a WalletModalProvider' +
        ' as an ancestor of the component that uses ' +
        'WalletModalContext');
}
export var WalletModalContext = React.createContext(DEFAULT_CONTEXT);
export function useWalletModal() {
    return React.useContext(WalletModalContext);
}
