var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
// import '../style.css';
import { useMemo } from 'react';
import bs58 from 'bs58';
import { ConnectionProvider, WalletProvider, } from '@solana/wallet-adapter-react';
import { Keypair } from '@solana/web3.js';
import { E2EWalletAdapter } from '../adapters/e2e';
import { DemonWalletAdapter } from '../adapters/index';
import { getNetworkUrls, isRunningInCypress, } from '../helpers';
import { WalletModalProvider, } from './WalletModalProvider';
export var Provider = function (_a) {
    var children = _a.children, isMainnet = _a.isMainnet, e2eWalletPrivKey = _a.e2eWalletPrivKey, endpoint = _a.endpoint, modalProviderProps = __rest(_a, ["children", "isMainnet", "e2eWalletPrivKey", "endpoint"]);
    var wallets = useMemo(function () {
        var supportedWallets = [];
        if (isRunningInCypress) {
            if (e2eWalletPrivKey) {
                supportedWallets.push(
                // @ts-ignore
                new E2EWalletAdapter({
                    keypair: Keypair.fromSecretKey(bs58.decode(e2eWalletPrivKey))
                }));
            }
            // // @ts-ignore
            // supportedWallets.push(new E2EWalletAdapter())
        }
        else {
            supportedWallets.push(new DemonWalletAdapter());
        }
        return supportedWallets;
    }, []);
    var urls = useMemo(function () { return endpoint || getNetworkUrls(isMainnet); }, []);
    return (_jsx(ConnectionProvider, __assign({ endpoint: urls.rpc, config: {
            wsEndpoint: urls.wss,
            commitment: 'confirmed',
        } }, { children: _jsx(WalletProvider, __assign({ wallets: wallets, autoConnect: true }, { children: _jsx(WalletModalProvider, __assign({}, modalProviderProps, { children: children })) })) })));
};
